<?php
	abstract class __autoupdate extends baseModuleAdmin {


		public function versions() {
			$regedit = regedit::getInstance();
			$systemEdition = $regedit->getVal("//modules/autoupdate/system_edition");
			$systemEditionStatus = "%autoupdate_edition_" . $systemEdition . "%";
			
			if($systemEdition == "commerce_trial") {
				$daysLeft = $regedit->getDaysLeft();
				$systemEditionStatus .= " ({$daysLeft} " . getLabel('label-days-left') . ")";
			}
			$systemEditionStatus = templater::getInstance()->putLangs($systemEditionStatus);

			$params = Array(
				"autoupdate" => Array(
					"status:system-edition"		=> NULL,
					"status:last-updated"		=> NULL,
					"status:system-version"		=> NULL,
					"status:system-build"		=> NULL,
					"status:db-driver"			=> NULL,
					"boolean:disabled"			=> NULL
				)
			);


			$params['autoupdate']['status:system-version'] = $regedit->getVal("//modules/autoupdate/system_version");
			$params['autoupdate']['status:system-build'] = $regedit->getVal("//modules/autoupdate/system_build");
			$params['autoupdate']['status:system-edition'] = $systemEditionStatus;
			$params['autoupdate']['status:last-updated'] = date("Y-m-d H:i:s", $regedit->getVal("//modules/autoupdate/last_updated"));
			
			$db_driver = "mysql";
			if(defined("DB_DRIVER")) {
				$db_driver = DB_DRIVER;
			}
			$params['autoupdate']['status:db-driver'] = $db_driver;



			$autoupdates_disabled = false;
			if(defined("CURRENT_VERSION_LINE")) {
				if(in_array(CURRENT_VERSION_LINE, array("start", "demo"))) {
					$autoupdates_disabled = true;
				}
			}

			$params['autoupdate']['boolean:disabled'] = (int) $autoupdates_disabled;


			$this->setDataType("settings");
			$this->setActionType("view");

			$data = $this->prepareData($params, "settings");

			$this->setData($data);
			return $this->doData();
		}

	};
?>